Bug 1315020 - Review Request: python-nmrglue - Python module for processing NMR data
Review Request: python-nmrglue - Python module for processing NMR data
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jonathan Underwood
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-03-05 13:49 EST by Mukundan Ragavan
Modified: 2016-03-26 14:14 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-20 16:23:30 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jonathan.underwood: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Mukundan Ragavan 2016-03-05 13:49:25 EST
Spec URL: https://nonamedotc.fedorapeople.org/pkgreview/nmrglue/python-nmrglue.spec
SRPM URL: https://nonamedotc.fedorapeople.org/pkgreview/nmrglue/python-nmrglue-0.5-1.fc23.src.rpm

Description:
nmrglue has the ability to read, write and convert between a number of common NMR file formats including Varian, Bruker, NMRPipe, and Sparky files. The files, which are represented in python as dictionaries of spectral parameters and Numpy array objects, can be easily examined, modified and processed as desired.

nmrglue provides a number of common functions for processing NMR data such as apodization, spectral shifting, Fourier and other transformations, baseline smoothing and flattening, and linear prediction. In addition new processing schemes can be implemented easily using the nmrglue provided functions and the multitude of numerical routines provided by the Numpy and Scipy packages.

When used in conjunction with the matplotlib (or other) python plotting library nmrglue can be used to create publication quality figures of NMR spectrum or examine data interactively.

nmrglue can be used to analysis NMR data, with routines to perform peak picking, multidimensional lineshape fitting (peak fitting), and peak integration. New analysis methods can be rapidly developed and tested in Python or by integrating Fortran and C/C++ code.

Fedora Account System Username: nonamedotc
Comment 1 Mukundan Ragavan 2016-03-05 13:50:22 EST
koji scratch build - https://koji.fedoraproject.org/koji/taskinfo?taskID=13241704
Comment 2 Jonathan Underwood 2016-03-05 16:18:07 EST
Couple of quick comments:

1/ Presumably these two deps of the main package:

Requires:	numpy
Requires:	scipy

Should actually be deps of each of the python[2,3] subpackages (python3-numpy and python3-scipy in the py 3 case

2/ Having that exact same long description 3 times in the spec file is an eyeful. Perhaps define a macro to store the text. Consider shortening the text too - that's a lot of detail. Ideally the descriptions for the py2 and py3 sub-packages would mention that they provide support for Python 2 and Python 3 respectively.
Comment 3 Mukundan Ragavan 2016-03-05 17:11:32 EST
(In reply to Jonathan Underwood from comment #2)
> Couple of quick comments:
> 
> 1/ Presumably these two deps of the main package:
> 
> Requires:	numpy
> Requires:	scipy
> 
> Should actually be deps of each of the python[2,3] subpackages
> (python3-numpy and python3-scipy in the py 3 case
> 

True! That's fixed now.

> 2/ Having that exact same long description 3 times in the spec file is an
> eyeful. Perhaps define a macro to store the text. Consider shortening the
> text too - that's a lot of detail. Ideally the descriptions for the py2 and
> py3 sub-packages would mention that they provide support for Python 2 and
> Python 3 respectively.

I was debating about this myself. I have just left this in the spec file now.

"nmrglue is a module for working with NMR data in Python. When used with the 
numpy, scipy, and matplotlib packages nmrglue provides a robust interpreted 
environment for processing, analyzing, and inspecting NMR data."
Comment 4 Jonathan Underwood 2016-03-06 04:03:57 EST
When you update your package, you need bump the release number of the package and add a comment to this ticket with the Spec URL and SRPM URL specified exactly as you did in Comment #1 - this allows the fedora-review tool to automatically download the srpm and spec and perform the automated part of the review process. If you do that, I'll pick up this review for you.
Comment 6 Mukundan Ragavan 2016-03-06 07:47:02 EST
(In reply to Jonathan Underwood from comment #4)
> When you update your package, you need bump the release number of the
> package and add a comment to this ticket with the Spec URL and SRPM URL
> specified exactly as you did in Comment #1 - this allows the fedora-review
> tool to automatically download the srpm and spec and perform the automated
> part of the review process. If you do that, I'll pick up this review for you.

I hadn't realized you had already pulled using fedora-review - that's why didn't bump the release! :)

Thanks for taking the package.
Comment 7 Jonathan Underwood 2016-03-07 06:07:23 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Summary: 
1) Fix source URL
2) Add %check
3) Don't bundle tests
4) Encourage upstream to put license headers at top of files

More detail below...


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 33 files have unknown license. Detailed
     output of licensecheck in /home/jgu/Fedora/1315020-python-
     nmrglue/licensecheck.txt

Would be nice if upstream added license headers to these files - it's
worth asking, but this isn't a review blocker.

[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.5/site-packages,
     /usr/lib/python3.5

This is a false positive - the python3 packages requires python(abi) =
3.5, which will pull in python, which owns those directories.

[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.5/site-
     packages, /usr/lib/python3.5

As above.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-nmrglue , python3-nmrglue
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.

At the very least you should have a %check section which runs python
and loads the modules from the buildroot (i.e. not from the sources) -
check other python packages for examples of this.

Also I note that the fileio has included tests - these could be run
during %check.

And actually, you probably don't want to be packaging the tests.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-nmrglue-0.5-2.fc25.noarch.rpm
          python3-nmrglue-0.5-2.fc25.noarch.rpm
          python-nmrglue-0.5-2.fc25.src.rpm
python2-nmrglue.noarch: W: spelling-error %description -l en_US numpy -> bumpy, lumpy, dumpy
python2-nmrglue.noarch: W: spelling-error %description -l en_US scipy -> spicy, Scipio
python2-nmrglue.noarch: W: spelling-error %description -l en_US matplotlib -> diplomatic
python3-nmrglue.noarch: W: spelling-error %description -l en_US numpy -> bumpy, lumpy, dumpy
python3-nmrglue.noarch: W: spelling-error %description -l en_US scipy -> spicy, Scipio
python3-nmrglue.noarch: W: spelling-error %description -l en_US matplotlib -> diplomatic
python-nmrglue.src: W: spelling-error %description -l en_US numpy -> bumpy, lumpy, dumpy
python-nmrglue.src: W: spelling-error %description -l en_US scipy -> spicy, Scipio
python-nmrglue.src: W: spelling-error %description -l en_US matplotlib -> diplomatic
python-nmrglue.src: W: invalid-url Source0: https://github.com/jjhelmus/nmrglue/releases/download/v0.5/nmrglue-0.5.tar.gz HTTP Error 403: Forbidden
3 packages and 0 specfiles checked; 0 errors, 10 warnings.

-----> Check the source URL and fix.

https://fedoraproject.org/wiki/Packaging:SourceURL


Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
python2-nmrglue (rpmlib, GLIBC filtered):
    python(abi)
    python2-numpy
    python2-scipy

python3-nmrglue (rpmlib, GLIBC filtered):
    python(abi)
    python3-numpy
    python3-scipy



Provides
--------
python2-nmrglue:
    python-nmrglue
    python2-nmrglue

python3-nmrglue:
    python3-nmrglue



Source checksums
----------------
https://github.com/jjhelmus/nmrglue/releases/download/v0.5/nmrglue-0.5.tar.gz :
  CHECKSUM(SHA256) this package     : a05c880bd0d5f0b388156409e18a5618742f829f2532d19970d05b11bfcc6103
  CHECKSUM(SHA256) upstream package : a05c880bd0d5f0b388156409e18a5618742f829f2532d19970d05b11bfcc6103


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1315020
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 8 Mukundan Ragavan 2016-03-07 18:55:23 EST
> 
> Summary: 
> 1) Fix source URL

Fixed.

> 2) Add %check

Done.

> 3) Don't bundle tests

Done.

> 4) Encourage upstream to put license headers at top of files
> 
> [x]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "Unknown or generated". 33 files have unknown license. Detailed
>      output of licensecheck in /home/jgu/Fedora/1315020-python-
>      nmrglue/licensecheck.txt
> 
> Would be nice if upstream added license headers to these files - it's
> worth asking, but this isn't a review blocker.
> 

I will communicate with upstream about license headers.

> [!]: %check is present and all tests pass.
> 
> At the very least you should have a %check section which runs python
> and loads the modules from the buildroot (i.e. not from the sources) -
> check other python packages for examples of this.
> 
> Also I note that the fileio has included tests - these could be run
> during %check.
> 
> And actually, you probably don't want to be packaging the tests.
> 


Fixed.


Relevant sections of the spec file - 

1/ Not installing tests - 

# disable tests bundling
sed -i '/nmrglue.fileio.tests/d' setup.py
sed -i '/package_data/d' setup.py
sed -i '/fileio\/tests\/data\//d' setup.py


2/ run tests

pushd nmrglue/fileio/tests
 
# python2 tests
PYTHONPATH="%{buildroot}%{python2_sitelib}" %{__python2} test_pipe.py
 
#python3 tests
PYTHONPATH="%{buildroot}%{python3_sitelib}" %{__python3} test_pipe.py
 
popd



> python-nmrglue.src: W: invalid-url Source0:
> https://github.com/jjhelmus/nmrglue/releases/download/v0.5/nmrglue-0.5.tar.
> gz HTTP Error 403: Forbidden
> 3 packages and 0 specfiles checked; 0 errors, 10 warnings.
> 
> -----> Check the source URL and fix.
> 
> https://fedoraproject.org/wiki/Packaging:SourceURL
> 

Fixed.
Comment 10 Jonathan Underwood 2016-03-08 08:42:38 EST
Ok, this is looking great. I'm going to set it as passed review, but I'd urge you to consider adding more tests during %check to check you can import other modules than just the fileio modules. You can do simple checks just to see if the module successfully imports. Eg. (taken from python-lz4.spec):

PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitearch} %{__python2} -c "import lz4"

These sorts of simple tests do actually catch breakage sometimes, so do have use.

Thanks for your contribution to Fedora, and thanks for being so quick to respond to the review.

APPROVED
Comment 11 Jonathan Underwood 2016-03-08 08:47:29 EST
(Of course you'd need to use sitelib rather than sitearch in the above example, but you get the idea).
Comment 12 Gwyn Ciesla 2016-03-09 08:52:35 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/python-nmrglue
Comment 13 Mukundan Ragavan 2016-03-09 18:50:26 EST
(In reply to Jonathan Underwood from comment #10)
> Ok, this is looking great. I'm going to set it as passed review, but I'd
> urge you to consider adding more tests during %check to check you can import
> other modules than just the fileio modules. You can do simple checks just to
> see if the module successfully imports. Eg. (taken from python-lz4.spec):
> 
> PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitearch} %{__python2} -c "import lz4"
> 
> These sorts of simple tests do actually catch breakage sometimes, so do have
> use.
> 
> Thanks for your contribution to Fedora, and thanks for being so quick to
> respond to the review.
> 
> APPROVED


I am going to email upstream about some tests that I see in the git repo. If the tests will not be added to next release, I will add additional tests like you have mentioned.

Thanks a lot for the quick review. Much appreciated.
Comment 14 Fedora Update System 2016-03-09 20:03:37 EST
python-nmrglue-0.5-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-3de505403e
Comment 15 Fedora Update System 2016-03-09 20:54:36 EST
python-nmrglue-0.5-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-3de505403e
Comment 16 Fedora Update System 2016-03-26 14:14:12 EDT
python-nmrglue-0.5-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.